# Generated by Django 4.2.4 on 2023-08-17 19:59

import aleksis.core.managers
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("core", "0053_freebusy"),
    ]

    operations = [
        migrations.CreateModel(
            name="AbsenceReason",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                ("short_name", models.CharField(max_length=255, verbose_name="Short name")),
                (
                    "name",
                    models.CharField(blank=True, max_length=255, null=True, verbose_name="Name"),
                ),
            ],
            options={
                "verbose_name": "Absence reason",
                "verbose_name_plural": "Absence reasons",
            },
            managers=[
                ("objects", aleksis.core.managers.AlekSISBaseManager()),
            ],
        ),
        migrations.CreateModel(
            name="Absence",
            fields=[
                (
                    "freebusy_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="core.freebusy",
                    ),
                ),
                ("comment", models.TextField(blank=True, verbose_name="Comment")),
                (
                    "person",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="kolego_absences",
                        to="core.person",
                        verbose_name="Person",
                    ),
                ),
                (
                    "reason",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="absences",
                        to="kolego.absencereason",
                        verbose_name="Absence reason",
                    ),
                ),
            ],
            options={
                "verbose_name": "Absence",
                "verbose_name_plural": "Absences",
            },
            bases=("core.freebusy",),
        ),
        migrations.AddConstraint(
            model_name="absencereason",
            constraint=models.UniqueConstraint(
                fields=("short_name",),
                name="kolego_unique_short_name_per_site_absence_reason",
            ),
        ),
    ]
